"use strict";

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var fs = require('fs/promises');

var path = require('path');
/**
 * @description 覆盖性的Copy文件夹函数
 * @param {String} sourceFolder
 * @param {String} targetFolder
 * @return {Promise}
 */


function copyFolder(sourceFolder, targetFolder) {
  // 覆盖性Copy
  // 创建目标文件夹
  return fs.mkdir(targetFolder).then(function () {
    console.log("".concat(targetFolder, " \u76EE\u6807\u6587\u4EF6\u5939\u521B\u5EFA\u5B8C\u6210"));
  })["catch"](function (error) {
    return console.log(error);
  }).then(function () {
    return fs.readdir(sourceFolder, {
      withFileTypes: true
    });
  }).then(function (entries) {
    var fileCount = 0;
    var folderCount = 0;
    return new Promise(function (resolve) {
      var _iterator = _createForOfIteratorHelper(entries),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var entry = _step.value;
          var sourcePath = path.join(sourceFolder, entry.name);
          var targetPath = path.join(targetFolder, entry.name);
          entry.isDirectory() ? copyFolder(sourcePath, targetPath).then(function () {
            folderCount++;
            if (fileCount + folderCount === entries.length) resolve(true);
          })["catch"](function (error) {
            return console.log(error);
          }) : fs.copyFile(sourcePath, targetPath).then(function () {
            fileCount++;
            if (fileCount === entries.length) resolve(true);
          })["catch"](function (error) {
            return console.log(error);
          });
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    });
  });
}

module.exports = {
  copyFolder: copyFolder
};